<!doctype html>
<html lang="en">

<head>
    <title>Nhân Viên 43.140</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Import DataTable Library -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container-fluid">
        <h3 class="my-3 text-center">DANH SÁCH ĐƠN HÀNG</h3>
        <div class="jumbotron">
            <div class="row">
                <div class="col-sm-2 text-right">
                    <label for="">Loại pizza</label>
                </div>
                <div class="col-sm-3">
                    <select name="" id="select-loai-pizza" class="form-control">
                        <option value="">Chọn loại pizza</option>
                    </select>
                </div>
                <div class="col-sm-2 text-right">
                    <label for="">Trạng thái</label>
                </div>
                <div class="col-sm-3">
                    <select name="" id="select-trang-thai" class="form-control">
                        <option value="">Chọn Trạng thái</option>
                    </select>
                </div>
                <div class="col-sm-2">
                    <button id="btn-filter" class="btn btn-success form-control">Filter</button>
                </div>
            </div>
        </div>
        <table id="table-user" class="table table-bordered table-striped">
            <thead>
                <tr>
                    <th>Order Code</th>
                    <th>Kích cỡ combo</th>
                    <th>Loại Pizza</th>
                    <th>Nước uống</th>
                    <th>Thành tiền</th>
                    <th>Họ và tên</th>
                    <th>Số điện thoại</th>
                    <th>Trạng thái</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
    <!-- modal chi tiet -->
    <div id="modal-detail" class="modal" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Order Detail</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <label for="">Order Code</label>
                    <input type="text" name="" id="inp-order-code" class="form-control mb-3">
                    <label for="">Pizza size</label>
                    <input type="text" name="" id="inp-kich-co" class="form-control mb-3">
                    <label for="">Đường kính</label>
                    <input type="text" name="" id="inp-duong-kinh" class="form-control mb-3">
                    <label for="">Sườn</label>
                    <input type="text" name="" id="inp-suon" class="form-control mb-3">
                    <label for="">Salad</label>
                    <input type="text" name="" id="inp-salad" class="form-control mb-3">
                    <label for="">Pizza type</label>
                    <input type="text" name="" id="inp-loai-pizza" class="form-control mb-3">
                    <label for="">idVourcher</label>
                    <input type="text" name="" id="inp-id-vourcher" class="form-control mb-3">
                    <label for="">Thành tiền</label>
                    <input type="text" name="" id="inp-thanh-tien" class="form-control mb-3">
                    <label for="">Giảm giá</label>
                    <input type="text" name="" id="inp-giam-gia" class="form-control mb-3">
                    <label for="">Loại đồ uống</label>
                    <input type="text" name="" id="inp-loai-do-uong" class="form-control mb-3">
                    <label for="">Số lượng nước</label>
                    <input type="text" name="" id="inp-so-luong-nuoc" class="form-control mb-3">
                    <label for="">Họ và Tên</label>
                    <input type="text" name="" id="inp-ho-ten" class="form-control mb-3">
                    <label for="">Email</label>
                    <input type="text" name="" id="inp-email" class="form-control mb-3">
                    <label for="">Số điện thoại</label>
                    <input type="text" name="" id="inp-so-dien-thoai" class="form-control mb-3">
                    <label for="">Địa chỉ</label>
                    <input type="text" name="" id="inp-dia-chi" class="form-control mb-3">
                    <label for="">Lời nhắn</label>
                    <input type="text" name="" id="inp-loi-nhan" class="form-control mb-3">
                    <label for="">Ngày Order</label>
                    <input type="text" name="" id="inp-ngay-tao" class="form-control mb-3">
                    <label for="">Ngày chỉnh sửa</label>
                    <input type="text" name="" id="inp-ngay-sua" class="form-control mb-3">

                </div>

                <div class="row mx-2 my-3">
                    <div class="col-sm-6">
                        <button id="btn-confirm" type="button" class="btn btn-warning form-control">Confirm</button>
                    </div>
                    <div class="col-sm-6">
                        <button id="btn-cancel" type="button" class="btn btn-danger form-control">Cancel</button>
                    </div>



                </div>
            </div>
        </div>
    </div>
    <!-- end modal -->

</body>
<script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gCOL_NAME = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
    const gCOL_ORDER_CODE = 0;
    const gCOL_KICH_CO = 1;
    const gCOL_LOAI_PIZZA = 2;
    const gCOL_NUOC_UONG = 3;
    const gCOL_THANH_TIEN = 4;
    const gCOL_HO_TEN = 5;
    const gCOL_SO_DIEN_THOAI = 6;
    const gCOL_TRANG_THAI = 7;
    const gCOL_ACTION = 8;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders"
    var gDataOrder = "";
    var gDataAll = "";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        onLoadDataTable();
        loadDataSelectLoaiPizza();
        loadDataSelectTrangThai();
        $("#table-user").on("click", ".btn-detail", function () {
            gDataOrder = getDataRowTable(this);
            console.log(gDataOrder);
            $("#modal-detail").modal().show;
            onBtnDetail();
        })
        $("#btn-confirm").on("click", function () {
            onBtnUpdateConfirm();
        })
        $("#btn-cancel").on("click", function () {
            onBtnUpdateCancel();

        })
        $("#btn-filter").on("click", function () {
            onBtnFilter();
        })
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        $("#table-user").DataTable({
            columns: [
                { "data": gCOL_NAME[gCOL_ORDER_CODE] },
                { "data": gCOL_NAME[gCOL_KICH_CO] },
                { "data": gCOL_NAME[gCOL_LOAI_PIZZA] },
                { "data": gCOL_NAME[gCOL_NUOC_UONG] },
                { "data": gCOL_NAME[gCOL_THANH_TIEN] },
                { "data": gCOL_NAME[gCOL_HO_TEN] },
                { "data": gCOL_NAME[gCOL_SO_DIEN_THOAI] },
                { "data": gCOL_NAME[gCOL_TRANG_THAI] },
                { "data": gCOL_NAME[gCOL_ACTION] },

            ],
            columnDefs: [
                {
                    targets: gCOL_ACTION,
                    defaultContent: '<button class="btn btn-primary btn-detail">Chi tiết</button>'
                }
            ]
        })
    }
    function onLoadDataTable() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            success: function (paramRes) {
                loadDataTable(paramRes);
                gDataAll = paramRes;
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        })
    }
    function onBtnDetail() {

        getDataModal();
    }
    function onBtnUpdateConfirm() {
        var vObjOrder = {
            trangThai: "confirmed",
        }
        $.ajax({
            url: gBASE_URL + "/" + gDataOrder.id,
            type: "PUT",
            data: JSON.stringify(vObjOrder),
            contentType: "application/json; charset=utf-8",
            success: function (paramRes) {
                handleUpdate();
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }

        })
    }
    function onBtnUpdateCancel() {
        var vObjOrder = {
            trangThai: "cancel",
        }
        $.ajax({
            url: gBASE_URL + "/" + gDataOrder.id,
            type: "PUT",
            data: JSON.stringify(vObjOrder),
            contentType: "application/json; charset=utf-8",
            success: function (paramRes) {
                handleUpdate();
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }

        })
    }
    function loadDataSelectLoaiPizza() {
        var vArray = ["Hawaii", "Seafood", "Bacon"];
        for (var bI = 0; bI < vArray.length; bI++) {
            $("#select-loai-pizza").append($("<option>", {
                text: vArray[bI],
                value: vArray[bI].toUpperCase(),
            }))
        }

    }
    function loadDataSelectTrangThai() {
        var vArray = ["Open", "Confirmed", "Cancel"];
        for (var bI = 0; bI < vArray.length; bI++) {
            $("#select-trang-thai").append($("<option>", {
                text: vArray[bI],
                value: vArray[bI].toUpperCase(),
            }))
        }

    }
    // filter
    function onBtnFilter() {

        var vFilterObj = {
            loaiPizza: "",
            trangThai: "",
        }
        getDataFilter(vFilterObj);
        var vArrayData = handelFilter(vFilterObj);
        console.log(vArrayData);
        loadDataTable(vArrayData);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // load data DataTable
    function loadDataTable(paramData) {
        var vTable = $("#table-user").DataTable();
        vTable.clear();
        vTable.rows.add(paramData);
        vTable.draw();
    }
    function getDataRowTable(paramElement) {

        var vTable = $("#table-user").DataTable();
        var vRow = $(paramElement).closest("tr");
        var vData = vTable.row(vRow).data();
        return vData;
    }
    // load data modal
    function getDataModal() {
        $("#inp-order-code").val(gDataOrder.orderCode);
        $("#inp-kich-co").val(gDataOrder.kichCo);
        $("#inp-duong-kinh").val(gDataOrder.duongKinh);
        $("#inp-suon").val(gDataOrder.suon);
        $("#inp-salad").val(gDataOrder.salad);
        $("#inp-loai-pizza").val(gDataOrder.loaiPizza);
        $("#inp-id-vourcher").val(gDataOrder.idVourcher);
        $("#inp-thanh-tien").val(gDataOrder.thanhTien);
        $("#inp-giam-gia").val(gDataOrder.giamGia);
        $("#inp-loai-do-uong").val(gDataOrder.idLoaiNuocUong);
        $("#inp-so-luong-nuoc").val(gDataOrder.soLuongNuoc);
        $("#inp-ho-ten").val(gDataOrder.hoTen);
        $("#inp-email").val(gDataOrder.email);
        $("#inp-so-dien-thoai").val(gDataOrder.soDienThoai);
        $("#inp-dia-chi").val(gDataOrder.diaChi);
        $("#inp-loi-nhan").val(gDataOrder.loiNhan);
        $("#inp-ngay-tao").val(gDataOrder.ngayTao);
        $("#inp-ngay-sua").val(gDataOrder.ngayCapNhat);

    }
    function handleUpdate() {
        alert("Cập nhật thành công!");
        $("#modal-detail").modal().hide;
        location.reload();

    }
    function getDataFilter(paramObj) {
        paramObj.loaiPizza = $("#select-loai-pizza").val();
        paramObj.trangThai = $("#select-trang-thai").val();
    }
    function handelFilter(paramObj) {

        var vResult = [];
        vResult = gDataAll.filter(function (item, index) {
            return (paramObj.loaiPizza == "Chọn loại pizza" || paramObj.loaiPizza === item.loaiPizza.toUpperCase())
                && (paramObj.trangThai == "Chọn Trạng thái" || paramObj.trangThai === item.trangThai.toUpperCase());


        })
        return vResult;
    }


</script>

</html>